import 'dart:async';

import 'package:bolter/bolter.dart';
import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:bolter_flutter/src/presenter/loading.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:provider/single_child_widget.dart';

part 'presenter/presenter.dart';
part 'presenter/presenter_provider.dart';

// ignore: avoid_implementing_value_types
abstract class UsecaseProvider implements Widget {
  factory UsecaseProvider({
    UseCaseContainer useCaseContainer,
    Key key,
    Widget child,
  }) = _UsecaseProvider;
}

class _UsecaseProvider extends InheritedWidget implements UsecaseProvider {
  _UsecaseProvider({
    this.useCaseContainer,
    Key key,
    Widget child,
  }) : super(key: key, child: child);

  final UseCaseContainer useCaseContainer;
  final _bolter = Bolter();

  static _UsecaseProvider of(BuildContext context) =>
      context.dependOnInheritedWidgetOfExactType(aspect: _UsecaseProvider);

  @override
  bool updateShouldNotify(_UsecaseProvider oldWidget) => false;
}
